<template>
  <q-page>
    <div class="column items-center">
      <q-editor
        class="q-mt-lg"
        v-model="descriptionText"
        min-height="5rem"
        style="max-width: 75%;" />
      <div class="text-subtitle6">A brief description of what is working for you</div>

      <div class="justify-end">
        <q-btn
          class="q-mt-sm q-mb-md"
          color="black"
          label ="Upload"
          @click="onDiseaseDataSubmit"/>
      </div>

      <q-infinite-scroll
        @load="fetchData"
        class=""
        style="
          width: 500px;
          max-width: 100%;"
        >
        <div v-for="(data, index) in datum" :key="index">
          <FeedPost
            :created-at="data.created_at"
            :description="data.description"
            :endorse-color="data.endorse_color"
            :deny-color="data.deny_color"
            :net-endorsement-value="data.net_endorsement_value"
            v-on:consensus="fetchConsensus(index)"
            v-on:endorsement="submitEndorsement($event, data, index)" />
        </div>

        <template v-slot:loading>
          <div class="row justify-center q-my-md">
            <q-spinner-dots color="black" size="40px" />
          </div>
        </template>
      </q-infinite-scroll>

    </div>

    <q-dialog
      v-model="dataDialog"
      persistent
      :maximized="maximizedToggle"
      transition-show="slide-up"
      transition-hide="slide-down"
    >
      <div class="bg-white q-pt-sm column items-center no-wrap">
        <q-icon
          name="close"
          v-close-popup
          class="q-pr-sm justify-end cursor-pointer"
          size="lg"
          style="width: 100%"
          color="blue-grey-3"
        />
        <q-form @submit="onCommentSubmit">
          <q-select
            v-model="commentType"
            :options="commentOptions"
            label="Type"
            name="type" />
          <q-input
            bottom-slots
            v-model="comment"
            label="Short description"
            name="comment"
            :rules="[val => !!val || 'Field is required']">
            <template v-slot:prepend>
              <q-icon name="fas fa-comments" />
            </template>
          </q-input>

          <q-input
            bottom-slots
            type="email"
            v-model="commentEmail"
            label="Email ID"
            name="email">
            <template v-slot:prepend>
              <q-icon name="fas fa-envelope" />
            </template>
            <template v-slot:append>
              <q-icon name="close" @click="text = ''" class="cursor-pointer" />
            </template>

            <template v-slot:hint>
              Optional
            </template>
          </q-input>

          <div class="row justify-end">
            <q-btn label="Submit" type="submit" color="black">
              <template v-slot:loading>
                <q-spinner-dots />
              </template>
            </q-btn>
          </div>
        </q-form>
      </div>
    </q-dialog>

  </q-page>
</template>

<script>
import FeedPost from 'components/FeedPost'

export default {
  name: 'PageIndex',

  components: {
    FeedPost
  },

  data () {
    return {
      descriptionText: '',
      dataDialog: false,
      maximizedToggle: true,
      datum: [],
      totalRecordsDisplayed: null,
      commentType: 'Feature request',
      comment: null,
      commentEmail: null,
      commentOptions: [
        {
          label: 'Feature request',
          value: 'feature_request'
        },
        {
          label: 'Feedback',
          value: 'feedback'
        },
        {
          label: 'Etc.',
          value: 'etc'
        }
      ],
      diseaseName: 'COVID-19',
      diseaseOptions: ['COVID-19'],
      drugName: '',
      patientAge: 0,
      patientSex: 'O',
      sexOptions: [
        {
          label: 'Female',
          value: 'F'
        },
        {
          label: 'Male',
          value: 'M'
        },
        {
          label: 'Others',
          value: 'O'
        }
      ],
      targetTreatment: null
    }
  },

  computed: {
    id: function () {
      return this.$q.localStorage.getItem('customID')
    }
  },

  methods: {
    fetchData (index, done) {
      var params = {}
      params.total_displayed_records = this.totalRecordsDisplayed

      this.$axios.get('/api/data', {
        params: params
      })
        .then((response) => {
          var data = response.data.data
          this.datum.push.apply(this.datum, data)
          if (data[data.length - 1]._id !== 'custom') {
            this.totalRecordsDisplayed = this.datum.length
          }
          this.fetchCSRF(response.headers)
          done()
        })
        .catch((error) => {
          console.log(error)
        })
    },

    onDiseaseDataSubmit () {
      this.$axios.post('/api/data', { description: this.descriptionText })
        .then((response) => {
          this.datum.unshift(response.data.data)
          this.descriptionText = ''
          this.submitEndorsement(1, response.data.data, 0)
        })
        .catch((error) => {
          console.log(error)
          this.$q.notify({
            message: 'Something went wrong. Please try in some time',
            progress: true
          })
        })
    },

    submitEndorsement (val, data, index) {
      this.$axios.post(`/api/data/${data._id}/endorsement`, {
        endorsement_value: val
      })
        .then((response) => {
          const value = response.data.endorsement.endorsement_value
          this.setActionButtonColor(value, index)
        })
        .catch((error) => {
          console.log(error)
          this.$q.notify({
            message: 'Something went wrong. Please try again later.',
            progress: true
          })
        })
    },

    setActionButtonColor (value, index) {
      var data = this.datum[index]
      if (value === 1) {
        data.endorse_color = 'primary'
        data.deny_color = ''
      } else if (value === 0) {
        data.endorse_color = ''
        data.deny_color = ''
      } else if (value === -1) {
        data.endorse_color = ''
        data.deny_color = 'negative'
      }
      this.datum.splice(index, 1, data)
      this.fetchNetEndorsements(index)
    },

    fetchConsensus (index) {
      this.userEndorsement(index)
      this.fetchNetEndorsements(index)
    },

    userEndorsement (index) {
      if (this.datum[index]._id !== 'custom') {
        this.$axios.get(`/api/data/${this.datum[index]._id}/endorsement/${this.id}`, {})
          .then((response) => {
            this.setActionButtonColor(response.data.endorsement.value, index)
          })
          .catch((error) => {
            console.log(error)
          })
      }
    },

    fetchNetEndorsements (index) {
      if (this.datum[index]._id !== 'custom') {
        this.$axios.get(`/api/data/${this.datum[index]._id}/endorsement`, {})
          .then((response) => {
            var data = this.datum[index]
            data.net_endorsement_value = response.data.endorsement.value
            this.datum.splice(index, 1, data)
          })
          .catch((error) => {
            console.log(error)
          })
      }
    },

    onCommentSubmit (evt) {
      this.$axios.post('/api/miscellaneous/comment', new FormData(evt.target))
        .then((response) => {
          this.$q.notify({
            message: 'Thanks for the feedback.',
            progress: true
          })
        })
        .catch((error) => {
          console.log(error)
        })
    },

    fetchCSRF (headers) {
      var token = headers['x-csrf-token']
      this.$axios.defaults.headers.common['x-csrf-token'] = token
    },

    setIDHeader () {
      if (this.$q.localStorage.has('customID')) {
        this.$axios.defaults.headers.common['custom-id'] = this.id
      } else {
        this.$axios.head('/api/data')
          .then((response) => {
            var val = response.headers['custom-id']
            this.$q.localStorage.set('customID', val)
            this.$axios.defaults.headers.common['custom-id'] = this.id
          })
          .catch((error) => {
            console.log(error)
          })
      }
    }
  },

  created () {
    this.setIDHeader()
  }
}
</script>
